package ru.ulstu.tsMethods.exponential;

import com.google.common.collect.ImmutableMap;
import ru.ulstu.models.exceptions.ModelingException;
import ru.ulstu.tsMethods.exponential.param.TimeSeriesMethodParam;

import java.util.Map;

public class ExponentialMethodParams {
    Map<TimeSeriesMethodParam, Double> paramsValues;

    public ExponentialMethodParams(Map<TimeSeriesMethodParam, Double> paramsValues) {
        this.paramsValues = paramsValues;
    }

    public Double getValue(TimeSeriesMethodParam paramName) throws ModelingException {
        if (paramsValues.containsKey(paramName)) {
            return paramsValues.get(paramName);
        } else {
            throw new ModelingException("Неизвестное название параметра для метода экспоненциального сглаживания");
        }
    }

    public static ExponentialMethodParams of(TimeSeriesMethodParam param1, Double value1) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1));
    }

    public static ExponentialMethodParams of(TimeSeriesMethodParam param1, Double value1, TimeSeriesMethodParam param2, Double value2) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1, param2, value2));
    }

    public static ExponentialMethodParams of(TimeSeriesMethodParam param1, Double value1, TimeSeriesMethodParam param2, Double value2, TimeSeriesMethodParam param3, Double value3) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1, param2, value2, param3, value3));
    }

    public static ExponentialMethodParams of(TimeSeriesMethodParam param1, Double value1, TimeSeriesMethodParam param2, Double value2, TimeSeriesMethodParam param3, Double value3, TimeSeriesMethodParam param4, Double value4) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1, param2, value2, param3, value3, param4, value4));
    }
}
